/*###########################################################################
#                                                                           #
#  							FMWIC								#
#                                                                           #
###########################################################################*/
#define __MENU002_C__
#include "project.h"

#define MIN_RSSI	23			/* RSSIl						*/

/* FMWI샂[h`		*/
#define MODE_NONE  0x40			/* ʏ탂[h						*/
#define MODE_PAUSE 0x41			/* |[Y(gύX)				*/
#define MODE_UP    0x82			/* XL(UP)				*/
#define MODE_DOWN  0x83			/* XL(DOWN)				*/

/* e^C}[ݒ				*/
#define AUTO_PAUSE_CLEAR 100	/* |[Y(100msecP)		*/
#define SET_FREQ_DELAY    50	/* ޲قɂgύX̎ۂɎgĂ܂ł̒x(10msecP) */
#define SEEK_POLL_TIME     7	/* XL̏ԊmFԊu(10msecP)	*/
#define TEXT_SCROLL_TIME  10	/* XN[Ԋu(10msecP) FMWIp		*/

/* RSSIOt\̈W		*/
#define RSSI_X1 7
#define RSSI_Y1 35
#define RSSI_X2 102
#define RSSI_Y2 65

/* g\̈W			*/
#define FREQ_VALUE_X1 67
#define FREQ_VALUE_Y1 18
#define FREQ_VALUE_X2 101
#define FREQ_VALUE_Y2 25

/* RSSIl\̈W			*/
#define RSSI_VALUE_X1 66
#define RSSI_VALUE_Y1 26
#define RSSI_VALUE_X2 94
#define RSSI_VALUE_Y2 33

/* [Jϐ錾						*/
static uint8_t rssiLv[16];

/* [J֐vg^Cv錾			*/
static void beep( SOUND_TYPE type );
static void drawInitScreen( void );
static void drawRSSI( uint16_t rssi );
static uint8_t convY( uint16_t rssi );
static uint8_t drawFreqInfo( uint16_t freq );
static void drawFreq( uint16_t freq );

/*****************************************************************************
*							FMWICCʏ
* Fvoid
* ߒlFvoid
*****************************************************************************/
void menu002( void )
{
	FM_ITEM st;
	uint8_t mode = MODE_NONE;
	uint8_t tickFreq = 1;			/* 0:Ȃ@1:g&\	*/
	uint8_t itemCount = 0;
	uint8_t itemIndex = 0;
	uint16_t freq = 0;

	/* VXeϐ		*/
	eep.screenIndex = 2;					/* 샂[hݒiFMj			*/
	sys.playMode = PLAY_STS_STOP;
	sys.screenOffCountDownTimer = eep.screenOffTimer;
	sys.notProccesCountDownTimer = NOT_PROCESS_SHUTDOWN_TIME;

	/* SDJ[hdOFF			*/
	uint8_t pow = 0;
	disk_ioctl( 0 ,CTRL_POWER ,&pow );

	/* \^WIݒ		*/
	itemCount = getStationItemCount();
	drawInitScreen();
	fmEnable();

	/*	C					*/
	keysClear();
	while ( 1 ) {
		wdt_reset();

		/* VXe				*/
		systemProcess();

		/* XLs̏	*/
		if ( ( mode & 0x80 ) && !sys.countDownTimer1 ) {

			/* FM׼޵ӼޭُԊmF	*/
			if ( fmCheckSeek( &freq ) == 0 ) {	/* V[N?		*/
				if ( ( freq >= FM_MIN_FREQ ) && ( freq <= FM_MAX_FREQ ) ) {
					drawFreq( freq );
				}
			} else {							/* V[N~?		*/
				if ( ( freq >= FM_MIN_FREQ ) && ( freq <= FM_MAX_FREQ ) ) {
					eep.fmFreq = freq;
				}
				tickFreq = 1;
				sys.countDownTimer1 = 0;
				mode = MODE_PAUSE;
			}

			sys.notProccesCountDownTimer = AUTO_PAUSE_CLEAR;
			sys.countDownTimer1 = SEEK_POLL_TIME;
		}

		/* |[Y̎			*/
		if ( ( mode == MODE_PAUSE ) && !sys.notProccesCountDownTimer ) {
			tickFreq = 1;
			mode = MODE_NONE;
		}

		/* MgύX̏	*/
		if ( tickFreq && ( ( mode == MODE_NONE ) || ( ( mode == MODE_PAUSE ) && !sys.countDownTimer1 ) ) ) {
			itemIndex = findStationItem( eep.fmFreq ,&st );
			drawFreqInfo( eep.fmFreq );
			if ( mode == MODE_NONE ) {
				sysDraw_playButton( BUTTON_ICON_PLAY ,ON );
			} else if ( mode == MODE_PAUSE ) {
				sysDraw_playButton( BUTTON_ICON_PAUSE ,ON );
			}

			vsResetPlayMode();
			fmTune( eep.fmFreq );
			vsResetRecordAdpcm();
			player_volume( eep.volume );
			SOFT_WAIT_MS( 250 );

			sys.screenOffCountDownTimer = eep.screenOffTimer;
			sys.countDownTimer1 = 0;
			tickFreq = 0;
		}

		/* ʏ퓮쎞ɊeXV	*/
		if ( mode == MODE_NONE ) {

			/* Xe[Vebv\	*/
			if ( !sys.countDownTimer2 ) {
				sysDraw_scrollNext();
				sys.countDownTimer2 = START_SCROLL_TIME2;

			/* Vbg_E^C}[\	*/
			} else if ( sys.tickShutdownCountDownTimer ) {
				sysDraw_shutDownButton();
				sys.tickShutdownCountDownTimer = 0;

			/* RSSI Ot\				*/
			} else if ( !sys.countDownTimer1 ) {
				drawRSSI( fmGetRssi() );
				sys.countDownTimer1 = RSSI_INTERVAL;
			}
		}

		/* {^					*/
		uint8_t ky = keysInkey();
		if ( ky != KEY_NOTHING ) {

			/* ԃ{^FVbg_E		*/
			if ( ky == ( KEY_RED | KEY_LONGPUSH_START ) ) {
				shutdown( SHUTDOWN_USER );

			/* {^Fv[[[hJ	*/
			} else if ( ky == ( KEY_BLACK | KEY_LONGPUSH_START ) ) {
				beep( SOUND_CHANGE_MODE );
				fmReset();
				break;

			/* {^Fݒ胁j[			*/
			} else if ( ky == ( KEY_BROWN | KEY_LONGPUSH_START ) ) {
				if ( mode == MODE_NONE ) {
					menu030();
					drawInitScreen();
					drawFreqInfo( eep.fmFreq );
					itemIndex = findStationItem( eep.fmFreq ,&st );
					sysDraw_playButton( BUTTON_ICON_PLAY ,ON );
				}
				keysClear();

			/* {^ZF̃Xe[VACe/XLJn	*/
			} else if ( ky == KEY_BLACK ) {
				if ( ( mode == MODE_NONE ) && ( itemCount != 0 ) ) {
					sysDraw_playButton( BUTTON_ICON_FF ,ON );
					beep( SOUND_CHANGE_STATION );
					if ( ++itemIndex >= itemCount ) {
						itemIndex = 0;
					}
					getStationItem( itemIndex ,&st );
					eep.fmFreq = st.freq;
					tickFreq = 1;

				} else if ( mode == MODE_PAUSE ) {
					sysDraw_playButton( BUTTON_ICON_FF ,ON );
					beep( SOUND_SEEK_START );
					strcpy_P( (char *)sys.textBuffer ,PSTR("XL") );
					sysDraw_scrollFirst( sys.textBuffer );
					fmStartSeek( eep.fmFreq ,1 ,MIN_RSSI );

					sys.notProccesCountDownTimer = AUTO_PAUSE_CLEAR;
					sys.countDownTimer1 = SEEK_POLL_TIME;
					mode = MODE_UP;

				} else if ( ( mode == MODE_UP ) || ( mode == MODE_DOWN ) ) {
					sysDraw_playButton( BUTTON_ICON_PAUSE ,ON );
					beep( SOUND_PAUSE );
					fmCheckSeek( &freq );
					if ( ( freq >= FM_MIN_FREQ ) && ( freq <= FM_MAX_FREQ ) ) {
						eep.fmFreq = freq;
					}
					fmReset();
					fmEnable();
					sys.countDownTimer1 = 0;
					tickFreq = 1;
					mode = MODE_PAUSE;
				}
				keysClear();

			/* {^ZFÕXe[VACe/XLJn	*/
			} else if ( ky == KEY_BROWN ) {
				if ( ( mode == MODE_NONE ) && ( itemCount != 0 ) ) {
					sysDraw_playButton( BUTTON_ICON_REV ,ON );
					beep( SOUND_CHANGE_STATION );
					if ( --itemIndex >= itemCount ) {
						itemIndex = itemCount - 1;
					}
					getStationItem( itemIndex ,&st );
					eep.fmFreq = st.freq;
					tickFreq = 1;

				} else if ( mode == MODE_PAUSE ) {
					sysDraw_playButton( BUTTON_ICON_REV ,ON );
					beep( SOUND_SEEK_START );
					strcpy_P( sys.textBuffer ,PSTR("XL") );
					sysDraw_scrollFirst( sys.textBuffer );
					fmStartSeek( eep.fmFreq ,0 ,MIN_RSSI );

					sys.notProccesCountDownTimer = AUTO_PAUSE_CLEAR;
					sys.countDownTimer1 = SEEK_POLL_TIME;
					mode = MODE_DOWN;

				} else if ( ( mode == MODE_UP ) || ( mode == MODE_DOWN ) ) {
					sysDraw_playButton( BUTTON_ICON_PAUSE ,ON );
					beep( SOUND_PAUSE );
					fmCheckSeek( &freq );
					if ( ( freq >= FM_MIN_FREQ ) && ( freq <= FM_MAX_FREQ ) ) {
						eep.fmFreq = freq;
					}
					fmReset();
					fmEnable();
					sys.countDownTimer1 = 0;
					tickFreq = 1;
					mode = MODE_PAUSE;
				}
				keysClear();

			/* ԃ{^ZF	|[Y/XL~	*/
			} else if ( ky == KEY_RED ) {
				if ( mode == MODE_NONE ) {
					sysDraw_playButton( BUTTON_ICON_PAUSE ,ON );
					drawRSSI( 0xffff );
					sysDraw_scrollFirst( sys.textBuffer );
					beep( SOUND_PAUSE );
					sys.notProccesCountDownTimer = AUTO_PAUSE_CLEAR;
					sys.screenOffCountDownTimer = 0xffff;
					mode = MODE_PAUSE;

				} else if ( mode == MODE_PAUSE ) {
					beep( SOUND_PAUSE );
					tickFreq = 1;
					mode = MODE_NONE;

				} else if ( ( mode == MODE_UP ) || ( mode == MODE_DOWN ) ) {
					sysDraw_playButton( BUTTON_ICON_PAUSE ,ON );
					beep( SOUND_PAUSE );
					fmCheckSeek( &freq );
					if ( ( freq >= FM_MIN_FREQ ) && ( freq <= FM_MAX_FREQ ) ) {
						eep.fmFreq = freq;
					}
					fmReset();
					fmEnable();
					sys.countDownTimer1 = 0;
					tickFreq = 1;
					mode = MODE_PAUSE;
				}
				keysClear();

			/* WO_CUPFUP	/ gύX		*/
			} else if ( ky == KEY_JOGUP ) {
				if ( mode == MODE_NONE ) {
					if ( eep.volume < VOLUME_MAXVALUE ) {
						player_volume( ++eep.volume );
						sysDraw_volume();
					}
				} else if ( mode == MODE_PAUSE ) {
					if ( eep.fmFreq < FM_MAX_FREQ ) {
						vsResetPlayMode();
						eep.fmFreq++;
						drawFreq( eep.fmFreq );
						sys.notProccesCountDownTimer = AUTO_PAUSE_CLEAR;
						sys.countDownTimer1 = SET_FREQ_DELAY;	/* gĒx	*/
						tickFreq = 1;
					}
				}

			/* WO_CDOWNFDOWN	/ gύX	*/
			} else if ( ky == KEY_JOGDOWN ) {
				if ( mode == MODE_NONE ) {
					if ( eep.volume > 0 ) {
						player_volume( --eep.volume );
						sysDraw_volume();
					}
				} else if ( mode == MODE_PAUSE ) {
					if ( eep.fmFreq > FM_MIN_FREQ ) {
						vsResetPlayMode();
						eep.fmFreq--;
						drawFreq( eep.fmFreq );
						sys.notProccesCountDownTimer = AUTO_PAUSE_CLEAR;
						sys.countDownTimer1 = SET_FREQ_DELAY;	/* gĒx	*/
						tickFreq = 1;
					}
				}
			}

			/* e^C}[Zbg	*/
			sys.screenOffCountDownTimer = eep.screenOffTimer;
		}
	}
}

/*****************************************************************************
*								BEEP
* FSOUND_TYPE type
* ߒlFvoid
*****************************************************************************/
static void beep( SOUND_TYPE type )
{
	vsResetPlayMode();
	player_sound( type );

	/* VS1053B^[hŃZbg	*/
	vsResetRecordAdpcm();
	vsLoadFlashCode( FL_VS_IMAFIX );
}

/*****************************************************************************
*									\
* Fvoid
* ߒlFvoid
*****************************************************************************/
static void drawInitScreen( void )
{
	char buf[8];

	lcdSetBrightness( 0 );

	sysDraw_cls();
	sysDraw_shutDownButton();
	sysDraw_repetButton();
	sysDraw_volume();
	sysDraw_battery();
	sysDraw_spectrum( 0xff );
	sysDraw_fileType( F_FMRADIO );
	sysDraw_playButton( BUTTON_ICON_PLAY ,ON );
	drawFreqInfo( eep.fmFreq );

	strcpy_P( buf ,PSTR("Freq") );
	g_putsAscii( FREQ_VALUE_X1 - 24 ,FREQ_VALUE_Y1 ,buf ,sys.gDrawMode ,0xffff ,0x0000 );

	strcpy_P( buf ,PSTR("MHz") );
	g_putsAscii( FREQ_VALUE_X1 + 30 ,FREQ_VALUE_Y1 ,buf ,sys.gDrawMode ,0xffff ,0x0000 );

	strcpy_P( buf ,PSTR("RSSI") );
	g_putsAscii( RSSI_VALUE_X1 - 23 ,RSSI_VALUE_Y1 ,buf ,sys.gDrawMode ,0xffff ,0x0000 );

	drawRSSI( 0xffff );

	lcdSetBrightness( eep.screenBrightness );
}

/*****************************************************************************
*								RSSIOt\
* Fuint16_t rssi RSSIl(0xffff:NA)
* ߒlFvoid
*****************************************************************************/
static void drawRSSI( uint16_t rssi )
{
	char buf[8];
	uint8_t x;

	/* NA						*/
	if ( rssi == 0xffff ) {

		/* RSSIl\̈NA			*/
		g_drawBoxF( sys.gDrawMode ,RSSI_VALUE_X1 ,RSSI_VALUE_Y1 ,RSSI_VALUE_X2 ,RSSI_VALUE_Y2 ,RGB(0,0,0) );

		/* OẗNA				*/
		g_drawBoxF( sys.gDrawMode ,RSSI_X1 ,RSSI_Y1 ,RSSI_X2 ,RSSI_Y2 ,RGB(0,0,0) );

		/* c`						*/
		g_drawBoxF( sys.gDrawMode ,RSSI_X1 ,RSSI_Y1 ,RSSI_X1 ,RSSI_Y2 ,RGB(180,180,200) );

		/* `						*/
		g_drawBoxF( sys.gDrawMode ,RSSI_X1 ,RSSI_Y2 ,RSSI_X2 ,RSSI_Y2 ,RGB(180,180,200) );

		/* RSSI`				*/
		g_drawBoxF( sys.gDrawMode ,RSSI_X1 + 2 ,convY(MIN_RSSI) ,RSSI_X2 ,convY(MIN_RSSI) ,RGB(255,150,0) );

		memset( rssiLv ,convY(0) ,sizeof(rssiLv) );

	/* \							*/
	} else {

		/* ÕOt				*/
		x = RSSI_X1 + 4;
		for ( uint8_t i = 1 ;i < sizeof(rssiLv) ;i++ ) {
			g_drawLine( sys.gDrawMode ,x ,rssiLv[ i - 1 ] ,x + 6 ,rssiLv[ i ] ,RGB(0,0,0) );
			x += 6;
		}

		/* RSSIlVtg					*/
		for ( uint8_t i = 0 ;i < sizeof(rssiLv) - 1 ;i++ ) {
			rssiLv[ i ] = rssiLv[ i + 1 ];
		}
		rssiLv[ sizeof(rssiLv) - 1 ] = convY( rssi );

		/* Ot`					*/
		x = RSSI_X1 + 4;
		for ( uint8_t i = 1 ;i < sizeof(rssiLv) ;i++ ) {
			g_drawLine( sys.gDrawMode ,x ,rssiLv[ i - 1 ] ,x + 6 ,rssiLv[ i ] ,RGB(255,0,150) );
			x += 6;
		}

		/* RSSI`				*/
		g_drawBoxF( sys.gDrawMode ,RSSI_X1 + 2 ,convY(MIN_RSSI) ,RSSI_X2 ,convY(MIN_RSSI) ,RGB(255,150,0) );

		/* RSSIl\					*/
		sprintf_P( buf ,PSTR("%5u") ,rssi );
		g_putsAscii( RSSI_VALUE_X1 ,RSSI_VALUE_Y1 ,buf ,sys.gDrawMode ,RGB(255,150,0) ,RGB(0,0,0) );
	}
}

/*****************************************************************************
*						RSSIlOtp̍Wɕϊ
* Fuint16_t rssi RSSIl
* ߒlFuint8_t       YWl
*****************************************************************************/
static uint8_t convY( uint16_t rssi )
{
	if ( rssi <= 10 ) {
		rssi = 0;
	} else {
		rssi -= 10;
	}

	if ( rssi >= ( RSSI_Y2 - RSSI_Y1 - 2 ) ) {
		rssi = ( RSSI_Y2 - RSSI_Y1 - 2 );
	}

	return ( RSSI_Y2 - rssi - 2 );
}

/*****************************************************************************
*						wg̃Xe[V\
* Fuint16_t freq g
* ߒlFuint8_t       Xe[VACeCfbNX(0xff:o^)
* Xe[V̂ꍇ́AdispScrollNext()֐ŃXN[\
*****************************************************************************/
static uint8_t drawFreqInfo( uint16_t freq )
{
	FM_ITEM st;

	/* Xe[V擾				*/
	uint8_t itemIndex = findStationItem( freq ,&st );

	/* ebvp쐬\		*/
	if ( itemIndex == 0xff ) {
		strcpy_P( sys.textBuffer ,PSTR("o^") );
	} else {
		strcpy( sys.textBuffer ,st.name );
	}
	sysDraw_scrollFirst( NULL );

	drawFreq( freq );

	return ( itemIndex );
}

/*****************************************************************************
*						glƃV[No[\
* Fuint16_t freq g
* ߒlFvoid
*****************************************************************************/
static void drawFreq( uint16_t freq )
{
	uint16_t seekPos;
	char buf[16];

	/* ʏ㕔Ɏg\				*/
	sprintf_P( buf ,PSTR("%3d.%d") ,freq / 10 ,freq % 10 );
	g_putsAscii( FREQ_VALUE_X1 ,FREQ_VALUE_Y1 ,buf ,sys.gDrawMode ,RGB(255,150,0) ,RGB(0,0,0) );

	/* V[No[\					*/
	seekPos = SCALE_CONVERT( freq - FM_MIN_FREQ ,FM_MAX_FREQ - FM_MIN_FREQ + 1 ,SEEK_VALUE_MAX + 1 );
	sysDraw_seekBar( seekPos );
}

