/*###########################################################################
#                                                                           #
#		SPIڑtbVuAT45DB161Dv䃂W[            		#
#				y[WTCY512oCgŒ			                        #
#				y[W4096(2MBytes)									#
#																			#
###########################################################################*/
#ifndef __AT45DB161D_H__
#define __AT45DB161D_H__

#include <avr/io.h>

/* Xe[^XWX^l				*/
#define FLASH_STS_READY_BUSY 0x80
#define FLASH_STS_COMPARE 0x40
#define FLASH_STS_PROTECT 0x02
#define FLASH_STS_PAGE_SIZE 0x01
#define FLASH_STS_DEVICE_DENSITY 0x2c

/* `bvZbg}N			*/
#define FLASH_ENABLE_RESET()	( PORTE &= ~_BV(7) )
#define FLASH_DISABLE_RESET()	( PORTE |=  _BV(7) )

/* `bvZNg}N			*/
#define FLASH_ENABLE_CS()		( PORTB &= ~_BV(0) )
#define FLASH_DISABLE_CS()		( PORTB |=  _BV(0) )

/* tbVobt@ԍ`		*/
#define FLASH_BUFFER1	0
#define FLASH_BUFFER2	1

/* Manufacturer id \̒`	*/
typedef struct FLSAH_MANUFACTUER_ID_t {
	uint8_t manufacturer;       /* Manufacturer id							*/
	uint8_t device[ 2 ];		/* Device id								*/
	uint8_t extendedInfoLength;	/* Extended device information string length*/
} FLSAH_MANUFACTUER_ID;

/* ֐vg^Cv錾			*/
uint8_t flashInit( void );
void flashRead( uint32_t address ,void *dat ,uint16_t len );
uint8_t flashWrite( uint32_t address ,void *dat ,uint16_t len );

uint8_t flashWritePage( uint16_t page ,void *dat );
void flashReadPage( uint16_t page ,void *dat );

uint8_t flashReadBYTE( void );
void flashReadBLOCK( void *dat ,uint16_t len );
void flashWriteBYTE( uint8_t dat );
void flashWriteBLOCK( void *dat ,uint16_t len );
uint8_t flashReadStatusRegister( void );
void flashReadManufacturerAndDeviceID( FLSAH_MANUFACTUER_ID *id );
void flashContinuousArrayRead( uint16_t page, uint16_t offset );
void flashBufferRead( uint8_t bufferNum ,uint16_t offset );
void flashBufferWrite( uint8_t bufferNum ,uint16_t offset );
void flashBufferToPage( uint8_t bufferNum ,uint16_t page );
void flashPageToBuffer( uint8_t bufferNum ,uint16_t page );
void flashEndAndWait( void );
uint8_t flashComparePageToBuffer( uint8_t bufferNum ,uint16_t page );

#endif
