/*###########################################################################
#                                                                           #
#                  @@@@OtBbN֘AW[						#
#                                                                           #
###########################################################################*/
#ifndef __GRAPHIC_H__
#define __GRAPHIC_H__

#ifndef NULL
#define NULL ( (void *)0 )
#endif

#ifndef NA
#define NA 0
#endif

/* 摜\[h				*/
typedef enum {
	G_OPAQUE = 0x00 ,						/* C[Ŵ܂ܕ`						*/
	G_HALF_ALL = 0x81 ,	 					/* SsNZ𔼓`						*/
	G_TRANSPARENT = 0x82 ,					/* wF𓧖ŕ` / ̑̐Fʏ`	*/
	G_HALF = 0x83		 					/* wF𓧖ŕ` / ̑̐F𔼓`	*/
} G_DRAWMODE;

/* BG(wi)ݒl				*/
typedef enum {
	G_BGMODE_COLOR ,						/* wFwiFƂ			*/
	G_BGMODE_IMAGE 							/* w摜wiƂ			*/
} G_BGMODE;

/* tHg\ (14bytes)		*/
typedef struct FONT_t {
	uint8_t codeType;						/* 0:ASCII 1:				*/
	uint8_t tnum;							/* codeType = 1 : Gg[	*/
	uint8_t xsize;							/* TCY						*/
	uint8_t ysize;							/* cTCY						*/
	uint8_t linePerBytes;					/* 1C̃oCg			*/
	uint8_t charPerBytes;					/* 1̃oCg				*/
	uint16_t entPage;						/* Gg[擪y[W			*/
	uint16_t entOffset;						/* Gg[擪ItZbg		*/
	uint32_t dataTop;						/* tHg擪AhX			*/
} FONT;

/* tHgZbg\ (28bytes)	*/
typedef struct FONT_SET_t {
	FONT hFont;
	FONT zFont;
} FONT_SET;

/* NbsO\(2bytes)			*/
typedef struct G_CLIP_t {
	uint8_t x2;		/* ̈EXW	*/
	uint8_t y2;		/* ̈EYW	*/
} G_CLIP;

/* eLXgXN[\\	*/
typedef struct G_SCROLL_t {
	FONT_SET *fontSet;						/* tHgZbg							*/
	char *s;								/* \ւ̃|C^					*/
	char *ss;								/* \Jnւ̃|C^					*/
	uint16_t fontColor;						/* \tHgF						*/
	uint16_t bgColor;
	G_DRAWMODE mode;
	uint8_t enable;							/* 0: 1:L							*/
	uint8_t xposOffset;						/* 擪tHg̉ItZbgl			*/
	uint8_t x ,y;							/* \GA̍W						*/
	uint8_t x1 ,x2;							/* \GA̍[^E[XW				*/
	uint8_t fontWidth;
	uint16_t code;							/* ݕ\̐擪R[h				*/
	uint8_t blankCount;						/* uNJE^							*/
	uint8_t setBlank;						/* ZbguN					*/
} G_SCROLL;

/* ֐vg^Cv錾			*/
uint8_t g_setBG( G_BGMODE mode ,uint16_t value );
void g_cls( void );
void g_drawLine( G_DRAWMODE mode ,uint8_t x1 ,uint8_t y1 ,uint8_t x2 ,uint8_t y2 ,uint16_t color );
void g_drawBoxF( G_DRAWMODE mode ,uint8_t x1 ,uint8_t y1 ,uint8_t x2 ,uint8_t y2 ,uint16_t color );
uint8_t g_drawFlashImage( uint16_t index ,G_DRAWMODE mode ,uint16_t color ,uint8_t x1 ,uint8_t y1 ,uint8_t x2 ,uint8_t y2 );
void g_drawSpectrum( uint16_t *dat ,G_DRAWMODE  mode ,uint8_t x ,uint8_t y );
uint8_t g_createFontSet( uint16_t han ,uint16_t zen ,FONT_SET *fnt );
void g_putsAscii( uint8_t x ,uint8_t y ,char *str ,G_DRAWMODE mode ,uint16_t fontColor ,uint16_t bgColor );
void g_puts( FONT_SET *fontSet ,uint8_t x ,uint8_t y ,char *str ,G_DRAWMODE mode ,uint16_t fontColor ,uint16_t bgColor );
uint8_t _g_puts( FONT_SET *fontSet ,uint8_t x ,uint8_t y ,uint8_t xclip ,uint8_t xposOffset ,char *str ,G_DRAWMODE mode ,uint16_t fontColor ,uint16_t bgColor );
void g_scrollFirst( FONT_SET *fontSet ,G_SCROLL *sp ,uint8_t x ,uint8_t y ,uint8_t xclip ,uint8_t blank ,char *str ,G_DRAWMODE mode ,uint16_t fontColor ,uint16_t bgColor );
void g_scrollNext( G_SCROLL *sp );

#endif
