/*###########################################################################
#                                                                           #
#  							Đt@CI								#
#                                                                           #
###########################################################################*/
#define __MENU011_C__
#include "project.h"

/* j[ʕ\̈	*/
#define ITEMS_OF_PAGE 6					/* Py[Wɕ\\ȃACe	*/
#define MX1 6							/* j[\̈捶XW		*/
#define MY1 26							/* j[\̈捶YW		*/
#define MX2 121							/* j[\̈EXW		*/
#define MY2 122							/* j[\̈EYW		*/

/* G[bZ[W\̈				*/
#define SX1 MX1
#define SY1 ( MY1 + ( ( MY2 - MY1 ) / 2 ) - 8 )
#define SX2 MX2
#define SY2 ( SY1 + 15 )

/* [Jϐ錾						*/
static PLAYLIST *list;
static G_SCROLL *sp;
static char *scrollText;				/* ACeebvp				*/

/* [J֐vg^Cv錾			*/
static void drawFullScreen( void );
static void drawItemList( void );
static void drawItem( uint8_t item ,uint8_t sel );

/*****************************************************************************
*							Đt@CI
* Fvoid
* ߒlFuint8_t 0:OK !0:ACh^C}[쓮
*****************************************************************************/
uint8_t menu011( void )
{
	/* ϐ							*/
	PLAYLIST _list;
	G_SCROLL _scrollInfo;
	char _scrollText[ LFN_LENGTH ];
	uint8_t screenUpdateFlag;

	list = &_list;
	sp = &_scrollInfo;
	scrollText = _scrollText;

	/* ݂̍ĐXg̕쐬			*/
	memcpy( list ,(void *)&sys.playList ,sizeof(PLAYLIST) );

	/* \								*/
	drawFullScreen();

	/*	C							*/
	sys.notProccesCountDownTimer = NOT_PROCESS_SHUTDOWN_TIME;
	while ( sys.notProccesCountDownTimer ) {
		wdt_reset();

		/* VXe						*/
		systemProcess();

		/* v[[obNOh		*/
		if ( player_process() != PLAY_STS_NONE ) {
			dspDisable();
			if ( sys.playMode != PLAY_STS_PLAYING ) {
				list->count = 0;
				list->path[0] = '\0';
				sys.backupPath[0] = sys.backupPath[1] = 0xff;
				sys.backupPath[2] = sys.backupPath[3] = 0x00;
				screenUpdateFlag = 1;
			} else if ( list->count == 0 ) {
				memcpy( list ,(void *)&sys.playList ,sizeof(PLAYLIST) );
				sys.backupPath[0] = sys.backupPath[1] = 0xff;
				sys.backupPath[2] = sys.backupPath[3] = 0x00;
				screenUpdateFlag = 1;
			}

			if ( ( player_afterPorcess() || screenUpdateFlag ) ) {
				drawFullScreen();
			}
			keysClear();
		}

		if ( ( sys.enableSpectrum ) && ( !sys.countDownTimer1 ) ) {
			sys.countDownTimer1 = SP_INTERVAL;
			sys.enableSpectrum = 0;
		}

		/* ACeebv\				*/
		if ( !sys.countDownTimer2 ) {
			sys.countDownTimer2 = SCROLL_INTERVAL;
			g_scrollNext( sp );
		}

		/* {^					*/
		uint8_t ky = keysInkey();
		if ( ky != KEY_NOTHING ) {

			/* ԃ{^FVbg_E				*/
			if ( ky == ( KEY_RED | KEY_LONGPUSH_START ) ) {
				shutdown( SHUTDOWN_USER );

			/* {^ZFOʂ֑J					*/
			} else if ( ky == KEY_BLACK ) {
				return ( 0 );

			/* ԃ{^ZFs							*/
			} else if ( ky == KEY_RED ) {
				if ( list->index < list->count ) {

					/* Đ									*/
					if ( list->items[list->index].atb == '0' ) {
						memcpy( (void *)&sys.playList ,list ,sizeof(PLAYLIST) );
						player_stop();
						player_sound( SOUND_TOP_OF_MUSIC );
						eep.resume.mode = RESUME_NONE;
						player_play( PLAY_CURRENT );

						dspDisable();
						if ( player_afterPorcess() ) {
							drawFullScreen();
						}

					/* fBNgړ						*/
					} else {
						dspDisable();
						if ( playList_moveChild( list ) != 0 ) {
							list->count = 0;
						}

						if ( sys.playMode & PLAY_STS_DSP_BIT ) {
							dspEnable();
						}

						drawItemList();
					}
				}

			/* {^ZF̃fBNgֈړ	*/
			} else if ( ky == KEY_BROWN ) {
				dspDisable();
				uint8_t ret = playLIst_moveParents( list );
				if ( sys.playMode & PLAY_STS_DSP_BIT ) {
					dspEnable();
				}
				if ( ret == 0 ) {
					drawItemList();
				} else if ( ret != 1 ) {
					list->count = 0;
					drawItemList();
				}

			/* WO_CUPFJ[\ړ				*/
			} else if ( ky == KEY_JOGUP ) {
				if ( list->index < list->count ) {
					if ( list->index < ( list->count - 1 ) ) {
						drawItem( list->index++ ,0 );
						if ( ( list->index % ITEMS_OF_PAGE ) == 0 ) {
							drawItemList();
						} else {
							drawItem( list->index ,1 );
						}
					}
				}

			/* WO_CDOWNFJ[\ړ				*/
			} else if ( ky == KEY_JOGDOWN ) {
				if ( list->index < list->count ) {
					if ( list->index > 0 ) {
						drawItem( list->index-- ,0 );
						if ( ( list->index % ITEMS_OF_PAGE ) == ( ITEMS_OF_PAGE - 1 ) ) {
							drawItemList();
						} else {
							drawItem( list->index ,1 );
						}
				 	}
				}
			}

			/* ^C}[Zbg		*/
			sys.notProccesCountDownTimer = NOT_PROCESS_SHUTDOWN_TIME;
		}
	}

	return ( 1 );
}

/*****************************************************************************
*							ʕ\
* Fvoid
* ߒlFvoid
*****************************************************************************/
static void drawFullScreen( void )
{
	sys.screenOffCountDownTimer = 0xffff;
	sys.screenBrightness = eep.screenBrightness;

	lcdSetBrightness( 0 );
	sysDraw_cls();
	sysDraw_battery();
	drawItemList();
	lcdSetBrightness( sys.screenBrightness );
	keysClear();
}

/*****************************************************************************
*							ACeXg\
* Fvoid
* ߒlFvoid
*****************************************************************************/
static void drawItemList( void )
{
	char pageText[14];
	uint8_t i;
	uint8_t itemIndex;
	uint8_t pageIndex;
	uint8_t pageCount;

	/* ʃNA				*/
	g_drawBoxF( G_HALF ,MX1 ,MY1 ,MX2 ,MY2 ,RGB(0,0,0) );

	strcpy_P( pageText ,PSTR("PAGE --/--") );

	/* SDJ[h}			*/
	if ( SD_INS() ) {
		strcpy_P( scrollText ,PSTR("SDJ[h}Ă܂") );
		g_scrollFirst( &sys.fnt2 ,sp ,SX1 ,SY1 ,SX2 ,4 , scrollText ,G_HALF ,RGB(255,255,255) ,RGB(0,0,0) );
		list->count = 0;
		list->path[0] = '\0';

	/* SDJ[hANZXG[	*/
	} else if ( list->index >= list->count ) {
		strcpy_P( scrollText ,PSTR("̃fBNgɂ̓ACe܂B") );
		g_scrollFirst( &sys.fnt2 ,sp ,SX1 ,SY1 ,SX2 ,4 , scrollText ,G_HALF ,RGB(255,255,255) ,RGB(0,0,0) );

	/* 1y[W\				*/
	} else {
		itemIndex = ( list->index / ITEMS_OF_PAGE ) * ITEMS_OF_PAGE;
		for ( i = 0 ;i < ITEMS_OF_PAGE ;i++ ) {
			drawItem( itemIndex ,itemIndex == list->index );
			itemIndex++;
		}

		/* y[WԍeLXg쐬	*/
		pageIndex = ( list->index / ITEMS_OF_PAGE ) + 1;
		pageCount = ( list->count + ITEMS_OF_PAGE - 1 ) / ITEMS_OF_PAGE;
		sprintf_P( pageText ,PSTR("PAGE %2d/%2d") ,pageIndex ,pageCount );
	}

	/* y[WԍeLXg\		*/
	g_putsAscii( 64 ,17 ,pageText ,sys.gDrawMode ,RGB(255,255,64) ,RGB(0,0,0) );

	sys.countDownTimer2 = START_SCROLL_TIME2;
}

/*****************************************************************************
*								ACe\
* Fuint8_t item ACeCfbNX
*		uint8_t sel  0:I 1:I
* ߒlFvoid
*****************************************************************************/
static void drawItem( uint8_t item ,uint8_t sel )
{
	uint8_t i;
	uint8_t y;
	char lfn[LFN_LENGTH];
	char dos[PLAY_LIST_PATH_LEGNTH];

	/* IĂACeLFN擾	*/
	if ( playList_getItemName( list ,item ,dos ) ) {
		strcpy_P( lfn ,PSTR("???") );

	} else {
		/* DSP]݋֎~				*/
		dspDisable();

		/* LFN擾							*/
		i = f_getLFN( dos ,lfn );

		/* DSP]荞ݕ				*/
		if ( sys.playMode & PLAY_STS_DSP_BIT ) {
			dspEnable();
		}

		/* UNICODE->S-JIS					*/
		if ( i == 0 ) {
			unicode_ConvSJIS( lfn ,PR_UTF16_UTF8_SJIS );
		}
	}

	/* t@CZꍇ̓Xy[XŃpbeBO	*/
	i = strlen( lfn );
	if ( i < 13 ) {
		strcat_P( lfn ,PSTR("             ") );
	}

	y = MY1 + ( ( item % ITEMS_OF_PAGE ) * 16 );
	if ( item < list->count ) {

		if ( list->items[item].atb == '0' ) {
			g_drawFlashImage( FL_ICON_START_INDEX + 8 ,sys.gDrawMode ,RGB(0,0,0) ,MX1 ,y ,MX1 + 15 ,y + 15 );
		} else {
			g_drawFlashImage( FL_ICON_START_INDEX + 9 ,sys.gDrawMode ,RGB(0,0,0) ,MX1 ,y ,MX1 + 15 ,y + 15 );
		}

		if ( sel ) {
			strcpy( scrollText ,lfn );
			g_scrollFirst( &sys.fnt2 ,sp ,MX1 + 18 ,y ,SX2 ,4 ,scrollText ,sys.gDrawMode ,RGB(0,0,64) ,RGB(0,255,0) );
			if ( i <= 12 ) {
				sp->enable = 0;
			} else {
				sys.countDownTimer2 = START_SCROLL_TIME2;
			}

		} else {
			_g_puts( &sys.fnt2 ,MX1 + 18 ,y ,SX2 ,0 ,lfn ,sys.gDrawMode ,RGB(255,255,255) ,RGB(0,0,0) );
		}
	}
}
