/*###########################################################################
#                                                                           #
#                 		drdLu[V  					#
#                                                                           #
###########################################################################*/
#define __SCREEN022_C__
#include "project.h"

/* [Jϐ錾						*/
static uint16_t value = 0;

/* [J֐vg^Cv錾			*/
static void drawItem( void );
static void drawFullScreen( void );

/*****************************************************************************
*						drdLu[V
* Fvoid
* ߒlFvoid
*****************************************************************************/
uint8_t menu022( void )
{
	uint16_t lv;
	uint32_t backup = eep.voltageCalibration;
	char buf[24];

	value = getBattVoltage();

	/* \									*/
	drawFullScreen();

	/*	C								*/
	sys.notProccesCountDownTimer = NOT_PROCESS_SHUTDOWN_TIME;
	while ( sys.notProccesCountDownTimer ) {

		/* _dl\						*/
		lv = _getBattVoltage();
		sprintf_P( buf ,PSTR("%d.%02d") ,lv / 100 ,lv % 100 );
		g_puts( &sys.fnt1 ,64 ,80 ,buf ,sys.gDrawMode ,RGB(255,255,255) ,RGB(0,0,0) );

		/* Tuj[obNOh		*/
		player_backProcess_for_submenu( &drawFullScreen );

		/* {^						*/
		uint8_t ky = keysInkey();
		if ( ky != KEY_NOTHING ) {

			/* ԃ{^FVbg_E	*/
			if ( ky == ( KEY_RED | KEY_LONGPUSH_START ) ) {
				shutdown( SHUTDOWN_USER );

			/* {^ZFOʂ֑J		*/
			} else if ( ky == KEY_BLACK ) {
				eep.voltageCalibration = backup;
				return ( 0 );

			/* ԃ{^ZFm				*/
			} else if ( ky == KEY_RED ) {
				return ( 0 );

			/* WO_CUPFJ[\ړ	*/
			} else if ( ky == KEY_JOGUP ) {
				if ( value < 420 ) {
					value++;
					eep.voltageCalibration = ( ( (uint32_t)value * 10000L ) / (uint32_t)lv );
					drawItem();
				}

			/* WO_CDOWNFJ[\ړ	*/
			} else if ( ky == KEY_JOGDOWN ) {
				if ( value > 300 ) {
					value--;
					eep.voltageCalibration = ( ( (uint32_t)value * 10000L ) / (uint32_t)lv );
					drawItem();
				}
			}

			/* ^C}[Zbg		*/
			sys.notProccesCountDownTimer = NOT_PROCESS_SHUTDOWN_TIME;
		}
	}

	return ( 1 );
}

/*****************************************************************************
*								ACe\
* Fuint8_t itemIndex ACeCfbNX 
*		uint8_t itemCount ACe
*		uint8_t sel       0:I 1:I
* ߒlFvoid
*****************************************************************************/
static void drawItem( void )
{
	char buf[24];
	uint16_t lv = getBattVoltage();
	sprintf_P( buf ,PSTR("%d.%02d") ,lv / 100 ,lv % 100 );
	g_puts( &sys.fnt1 ,64 ,93 ,buf ,sys.gDrawMode ,RGB(64,32,0) ,RGB(255,150,0) );
}

/*****************************************************************************
*							ʕ\
* Fvoid
* ߒlFvoid
*****************************************************************************/
static void drawFullScreen( void )
{
	char buf[24];

	sys.screenOffCountDownTimer = 0xffff;
	sys.screenBrightness = eep.screenBrightness;

	lcdSetBrightness( 0 );
	sysDraw_cls();
	sysDraw_battery();

	strcpy_P( buf ,PSTR("A/Dϊڰ") );
	g_puts( &sys.fnt1 ,13 ,18 ,buf ,sys.gDrawMode ,RGB(255,255,255) ,RGB(0,96,0) );

	strcpy_P( buf ,PSTR("obe[[q̓d") );
	g_puts( &sys.fnt1 ,10 ,34 ,buf ,sys.gDrawMode ,RGB(0,255,255) ,RGB(0,0,0) );
	
	strcpy_P( buf ,PSTR("𑪒肵l") );
	g_puts( &sys.fnt1 ,10 ,47 ,buf ,sys.gDrawMode ,RGB(0,255,255) ,RGB(0,0,0) );
	
	strcpy_P( buf ,PSTR("͂ĉB    ") );
	g_puts( &sys.fnt1 ,10 ,60 ,buf ,sys.gDrawMode ,RGB(0,255,255) ,RGB(0,0,0) );

	strcpy_P( buf ,PSTR("_d") );
	g_puts( &sys.fnt1 ,10 ,80 ,buf ,sys.gDrawMode ,RGB(255,255,255) ,RGB(0,0,0) );

	strcpy_P( buf ,PSTR("d") );
	g_puts( &sys.fnt1 ,10 ,93 ,buf ,sys.gDrawMode ,RGB(255,255,255) ,RGB(0,0,0) );

	drawItem();

	lcdSetBrightness( eep.screenBrightness );
	keysClear();
}
