/*###########################################################################
#                                                                           #
#  			        	v[[W[                                #
#                                                                           #
#                                                            Timer2/3gp #
###########################################################################*/
#define __PLAYER_C__

#define TIMER_NUM 3									/* WAIT_MS()Ŏgp^C}[ԍ		*/
#include "project.h"

/* MIDIĐ̒萔`					*/
#define SDI_SIZE	2048							/* DSPSDIobt@TCY(Œ)		*/

/* DSP]荞ݓϐ				*/
volatile static uint8_t regType = 0;				/* 擾郌WX^						*/
volatile static uint8_t dspBusy = 0;				/* MIDIp DSPԃtO 0:Ready 1:Busy*/
volatile static uint8_t endFillByte = 0;			/* endFillByte̒l						*/
volatile static uint16_t endFillByteCounter = 0;	/* MendFillByte ̐				*/
volatile static uint8_t fainaraizStep = 0;			/* t@CiCYXebvԍ			*/

/* ʃe[u							*/
static const prog_uint8_t volumeTable[ VOLUME_MAXVALUE + 1 ] = { 0 ,60 ,70 ,81 ,92 ,103 ,114 ,125 ,136 ,147 ,158 ,169 ,180 };

/*****************************************************************************
* timer2(8bit) 荞
*								DSPւ̓]
*****************************************************************************/
ISR( SIG_OUTPUT_COMPARE2A )
{
	uint16_t n = 0;

	/* DSPփt@C]							*/
	if ( sys.playMode == PLAY_STS_PLAYING ) {
		/* MIDIt@CĐDSP̃obt@\	*/
		if ( ( sys.playInfo.type == F_MIDI ) && VS_GET_DREQ() ) {
			uint32_t i = vsReadXmemDword( X_BYTES_LEFT );
			if ( i ) {
				i -= ( sys.playFL.fsize - sys.playFL.fptr );
				dspBusy = (uint8_t)( i > ( SDI_SIZE / 2 ) );
			}
		}

		if ( ( sys.playFL.fptr < sys.playFL.fsize ) && !dspBusy ) {
			if ( f_forward( (FIL *)&sys.playFL ,vsOutStream ,256 ,&n ) != FR_OK ) {
				sys.playMode = PLAY_STS_ERROR;
				dspDisable();
			}
		}

		/* t@CŌ܂œ]ꍇ̓t@CiCY	*/
		if ( sys.playFL.fptr >= sys.playFL.fsize ) {
			sys.playMode = PLAY_STS_FAINARAIZ;
			fainaraizStep = 0;
		}
	}

	/* t@CiCY									*/
	if ( sys.playMode == PLAY_STS_FAINARAIZ ) {
		switch ( fainaraizStep ) {

			/* Step 0 : ݒ							*/
			case 0:
				if ( VS_GET_DREQ() ) {
					endFillByte = (uint8_t)( vsReadXmem( X_ENDFILLBYTE ) & 0x00ff );
					endFillByteCounter = 2080;
					fainaraizStep = 101;
				}
				break;

			/* Step 1 : SM_CANCELs						*/
			case 1:
				if ( VS_GET_DREQ() ) {
					vsRegWrite( SCI_MODE ,vsRegRead( SCI_MODE ) | SM_CANCEL );
					endFillByteCounter = 2048;
					fainaraizStep = 102;
				}
				break;

			/* Step 2 : SM_CANCELs̊mF				*/
			case 2:
				n = 0;					/* XyAis[Nl^XyAil ALL 0 ܂ŃX[*/
				for ( uint8_t i = 0 ;i < VS_SPECTRUM_VALUES ;i++ ) {
					if ( sys.dsp_spectrum[ i ] ) {
						n = 1;
						break;
					}
				}

				if ( !n && VS_GET_DREQ() ) {
					if ( vsRegRead( SCI_HDAT0 ) || vsRegRead( SCI_HDAT1 ) ) {
						vsResetPlayMode();
					}
					f_close( (FIL *)&sys.playFL );
					fainaraizStep = 0;
					sys.playMode = PLAY_STS_FINISH; 
				}
				break;

			/* Step 101 , 102 : EndFillByte𑗐M			*/
			case 101:
			case 102:
				if ( endFillByteCounter == 0 ) {
					if ( fainaraizStep == 101 ) {
						fainaraizStep = 1;
					} else {
						fainaraizStep = 2;
					}

				} else {
					if ( ( sys.playInfo.type == F_MIDI ) && VS_GET_DREQ() ) {
						uint16_t i = (uint16_t)vsReadXmemDword( X_BYTES_LEFT );
						if ( i > 12 ) {				/* 12̍			*/
							n = 0;
						} else {
							n = 1;
						}
					} else {
						n = 32;
					}

					if ( endFillByteCounter < n ) {
						n = endFillByteCounter;
					}

					if ( n && VS_GET_DREQ() ) {
						endFillByteCounter -= vsOutFill( endFillByte ,n );
					}
				}
				break;

			default:
				break;
		}
	}

	/* XyAif[^擾												*/
	/* O sys.enableSpectrum NAȂƎ̃f[^͓ǂ܂Ȃ	*/
	if ( ( sys.enableSpectrum == 0 ) && ( VS_GET_DREQ() ) ) {
		vsRegWrite( SCI_WRAMADDR ,0x1804 );
		for ( uint8_t i = 0 ;i < VS_SPECTRUM_VALUES ;i++ ) {
			sys.dsp_spectrum[i] = vsRegRead( SCI_WRAM );
		}
		sys.enableSpectrum = 1;
	}

	/* DSPp[^擾									*/
	if ( ( sys.playInfo.type & GET_DSP_STATUS_BIT ) && VS_GET_DREQ() ) {
		if ( regType == 0 ) {
			sys.dsp_hDat0 = vsRegRead( SCI_HDAT0 );
		} else if ( regType == 20 ) {
			sys.dsp_hDat1 = vsRegRead( SCI_HDAT1 );
		} else if ( regType == 40 ) {
			sys.dsp_auData = ( vsRegRead( SCI_AUDATA ) & 0xfffe );
		}

		if ( ++regType >= 60 ) {
			regType = 0;
		}
	}

	/* ̊荞݃^C~Oݒ	*/
	TCNT2 = 0;
	TIFR2 = _BV(OCF2A);		/* ݂d׊ݒɍēx݃tOĂ܂	*/
}

/*****************************************************************************
*								DSP݋
* Fvoid
* ߒlFvoid
*****************************************************************************/
void dspEnable( void )
{
	TCCR2B = 0;
	TCNT2 = 0;
	OCR2A = 200;					/* F_CPU / 32 * 200 = 400usec	*/
	TCCR2B = 3;						/* F_CPU / 32					*/
	TIMSK2 |= _BV(OCIE2A);
	sys.dspTransFlag = 1;
}

/*****************************************************************************
*								DSP݋֎~
* Fvoid
* ߒlFvoid
*****************************************************************************/
void dspDisable( void )
{
	sys.dspTransFlag = 0;
	TIMSK2 &= ~_BV(OCIE2A);
	TCCR2B = 0;
	TCNT2 = 0;
}

/*****************************************************************************
*						v[[̃obNOh
* Fvoid
* ߒlFPLAYER_STS v[[Xe[^X( PLAY_STS_NONE == ԕω )
*****************************************************************************/
PLAYER_STS player_process( void )
{
	uint8_t val = 0;
	uint8_t ret;

	/* DSP]̃G[						*/
	if ( sys.playMode == PLAY_STS_ERROR ) {
		strcpy_P( sys.textBuffer ,PSTR("SDJ[hɃANZXł܂") );
		player_stop();							/* Đ~							*/
		sys.erroring = 1;
	}

	/* SDJ[h̏ԕω̏				*/
	if ( sys.flag_sdInsert != SD_INS() ) {
		sys.flag_sdInsert = SD_INS();
		player_stop();							/* Đ~							*/

		/* SDJ[h}Ԏ̏			*/
		if ( sys.flag_sdInsert ) {
			sys.playMode = PLAY_STS_NOT_INSERT;
			strcpy_P( sys.textBuffer ,PSTR("SDJ[h}Ă܂") );

		/* SDJ[h}Ԏ̏				*/
		} else {
			/* W[p[^LȏꍇAW[݂							*/
			/* W[p[^EW[s̓[gfBNg̐擪	*/
			ret = 1;
			if ( eep.resume.mode != RESUME_NONE ) {
				ret = playList_fileItem( (PLAYLIST *)&sys.playList ,(char *)eep.resume.fname );
			}

			if ( ret != 0 ) {
				ret = playList_findFastItem( (PLAYLIST *)&sys.playList );
				if ( ret == 0 ) {
					eep.resume.mode = RESUME_TOP;
				}
			}

			/*@W[sE[gfBNg擾s̏ꍇ̓G[Ƃ	*/
			if ( ret ) {
				sys.playMode = PLAY_STS_ACCESS_ERROR;
				strcpy_P( (char *)sys.textBuffer ,PSTR("SDJ[hփANZXłȂt@C܂B") );

			/* ĐJn		*/
			} else {
				if ( eep.resume.mode != RESUME_NONE ) {
					ret = player_play( PLAY_CURRENT );
					if ( ( ret == PLAY_STS_PLAYING ) || ( ret ==  PLAY_STS_NOT_SYPPORT ) ) {
						return ( ret );
					}
				}
			}
		}
	
		sys.erroring = 1;
	}

	/* RɋȂ̍ĐȈ			*/
	if ( sys.playMode == PLAY_STS_FINISH ) {
		/* ̍Đt@C擾				*/
		eep.resume.mode = RESUME_NONE;
		if ( playList_moveNext( (PLAYLIST *)&sys.playList ,eep.repetMode ) ) {
			sys.playMode = PLAY_STS_ACCESS_ERROR;
			strcpy_P( (char *)sys.textBuffer ,PSTR("SDJ[hANZXG[") );
		} else {
			player_play( PLAY_CURRENT );
			if ( ( sys.playMode == PLAY_STS_PLAYING ) || ( sys.playMode == PLAY_STS_NOT_SYPPORT ) ) {
				return ( player_play( PLAY_CURRENT ) );
			}
		}
		sys.erroring = 1;
	}

	/* G[̏ꍇ͍ĐXgEW[NA	*/
	if ( sys.erroring != 0 ) {
		memset( &sys.playList ,0x00 ,sizeof(PLAYLIST) );
		memset( (void *)&eep.resume ,0x00 ,sizeof(eep.resume) );
		disk_ioctl( 0 ,CTRL_POWER ,&val );
		return ( sys.playMode );
	}

	/* ʃtF[hCEtF[hAEg		*/
	player_volumeFade( VOLUME_FADE_NEXT );

	return ( PLAY_STS_NONE );
}

/*****************************************************************************
*						v[[ԕύX̏
* Fvoid
* ߒlFuint8_t 0:ʂNAKv͂܂
*				1:ʂNAKv܂
* player_process()֐PLAY_STS_NONEȊOԂꍇɌĂяo
*****************************************************************************/
uint8_t player_afterPorcess( void )
{
	uint8_t screenUpdateFlag = 0;

	/*											*/
	/* G[̏						*/
	/*											*/
	if ( sys.erroring != 0 ) {
		if ( sys.backupErroring == 0 ) {
			/* G[̔wi̓VXewiKp	*/
			sys.bgIndex = FL_BG_SYSTEM_INDEX;

			/* G[A͉OFF^C}[𖳌	*/
			sys.screenOffCountDownTimer = 0xffff;
			sys.screenBrightness = eep.screenBrightness;

			sys.backupPath[0] = sys.backupPath[1] = 0xff;
			sys.backupPath[2] = sys.backupPath[3] = 0x00;

			screenUpdateFlag = 1;
			sys.backupErroring = 1;
		}

	/*											*/
	/* Đ̏							*/
	/*											*/
	} else {
		/* wi摜`FW						*/
		if ( strcasecmp( sys.playList.path ,sys.backupPath ) != 0 ) {
			if ( ( eep.bgMode & 0x07 ) == 2 ) { 						/* Ao[hH */
				if ( sysDraw_changeAlbumBG( sys.playList.path ) == 0 ) {/* XV?	*/
					if ( sys.bgIndex != FL_BG_SYSTEM_INDEX ) {
						sys.bgIndex = FL_BG_SYSTEM_INDEX;
						screenUpdateFlag = 1;
					}
				} else {												/* XV?		*/
					screenUpdateFlag = 1;
				}
			}
		}

		/* G[A͉OFF^C}[𕜋A	*/
		if ( sys.backupErroring != 0 ) {
			sys.screenOffCountDownTimer = eep.screenOffTimer;
			sys.notProccesCountDownTimer = NOT_PROCESS_SHUTDOWN_TIME;
		}

		strcpy( sys.backupPath ,sys.playList.path );
		sys.backupErroring = 0;
	}

	/* DSP݋						*/
	if ( sys.playMode & PLAY_STS_DSP_BIT ) {
		dspEnable();
	}

	sys.erroring = 0;
	return ( screenUpdateFlag );
}

/*****************************************************************************
*				Tuj[ʐp̃v[[obNOh
* Fvoid (*func)( void ) ʍXṼR[obN֐
* ߒlFvoid
*****************************************************************************/
void player_backProcess_for_submenu( void (*func)( void ) )
{
	wdt_reset();
	systemProcess();
	if ( eep.screenIndex == 1 ) {
		if ( player_process() != PLAY_STS_NONE ) {
			dspDisable();
			if ( player_afterPorcess() ) {
				(*func)();
			}
			keysClear();
		}

		if ( ( sys.enableSpectrum ) && ( !sys.countDownTimer1 ) ) {
			sys.countDownTimer1 = SP_INTERVAL;
			sys.enableSpectrum = 0;
		}
	}
}

/*****************************************************************************
*						ʃtF[hCEAEg
* FVOLUME_FADE_MODE mode VOLUME_FADE_NONE : tF[hLZ
*							@VOLUME_FADE_IN   : ʃtF[hCJn
*						      VOLUME_FADE_OUT  : ʃtF[hAEgJn
*							  VOLUME_FADE_NEXT : Qڈȍ~̌Ăяo
* ߒlFVOLUME_FADE_MODE ݂̃tF[h
* VOLUME_FADE_NONE Ԃ܂ VOLUME_FADE_NEXT Ƃ
*   ̊֐Ăё邱
*****************************************************************************/
VOLUME_FADE_MODE player_volumeFade( VOLUME_FADE_MODE mode )
{
	static uint8_t volumeValue = 0;

	/* tF[hCEAEgLZ		*/
	if ( mode == VOLUME_FADE_NONE ) {
		sys.volumeFadeMode = VOLUME_FADE_NONE;

	/* tF[hCEAEgJn				*/
	} else if ( ( mode == VOLUME_FADE_IN ) || ( mode == VOLUME_FADE_OUT ) ) {
		volumeValue = vsGetVolume();
		sys.volumeFadeMode = mode;
		sys.countDownTimer3 = 0;

	} else if ( ( sys.volumeFadeMode != VOLUME_FADE_NONE ) && ( sys.countDownTimer3 == 0 ) ) {
		sys.countDownTimer3 = FADE_INTERVAL_TIME;

		/* tF[hC						*/
		if ( sys.volumeFadeMode == VOLUME_FADE_IN ) {
			volumeValue += FADE_IN_STEP;
			uint8_t limit = pgm_read_byte( &volumeTable[ eep.volume ] );
			if ( volumeValue >= limit ) {
				volumeValue = limit;
				sys.volumeFadeMode = VOLUME_FADE_NONE;
			}

		/* tF[hAEg					*/
		} else {
			volumeValue -= FADE_OUT_STEP;
			if ( ( volumeValue == 0 ) || ( volumeValue > 250 ) ) {
				volumeValue = 0;
				sys.volumeFadeMode = VOLUME_FADE_NONE;
			}
		}

		/* DSPʐݒ							*/
		dspDisable();
		vsSetVolume( volumeValue );
		if ( sys.playMode & PLAY_STS_DSP_BIT ) {
			dspEnable();
		}
	}

	return ( sys.volumeFadeMode );
}

/*****************************************************************************
*									ĐJn
* FPLAY_MODE mode	PLAY_CURRENT   : JgACe̍Đ(W[L)
*						PLAY_NEXT      : ̋ȂĐ
*						PLAY_BACK      : ŐȂĐ
* ߒlFPLAYER_STS      v[[Xe[^X
*****************************************************************************/
PLAYER_STS player_play( PLAY_MODE mode )
{
	uint16_t n;
	uint16_t t;

	/* Đ~							*/
	player_stop();

	/*											*/
	/* DSP								*/
	/* XyAiƍŐṼpb`͕płȂH	*/
	vsResetPlayMode();								/* Zbg			*/

	vsLoadFlashCode( FL_VS_SPECTRUM );				/* XyAi[h	*/
	vsRegWrite( SCI_WRAMADDR ,0x1801 );
	vsRegWrite( SCI_WRAM ,0 );

	vsLoadFlashCode( FL_VS_VORBISFIX );				/* pb`[h		*/

	vsSetVolume( 0 );

	/* JgACëړ			*/
	if ( ( mode == PLAY_NEXT ) || ( eep.resume.mode == RESUME_NEXT ) ) {
		if ( playList_moveNext( (PLAYLIST *)&sys.playList ,REPET_NONE ) ) {
			sys.playMode = PLAY_STS_ACCESS_ERROR;
			eep.resume.mode = RESUME_NONE;
			strcpy_P( (char *)sys.textBuffer ,PSTR("SDJ[hANZXG[") );
			return ( sys.playMode );
		}
		eep.resume.mode = RESUME_NONE;

	} else if ( mode == PLAY_BACK ) {
		if ( playList_moveBack( (PLAYLIST *)&sys.playList ,REPET_NONE ) ) {
			sys.playMode = PLAY_STS_ACCESS_ERROR;
			eep.resume.mode = RESUME_NONE;
			strcpy_P( (char *)sys.textBuffer ,PSTR("SDJ[hANZXG[") );
			return ( sys.playMode );
		}
		eep.resume.mode = RESUME_NONE;
	}

	/* JgACet@C擾	*/
	if ( playList_getItemName( (PLAYLIST *)&sys.playList ,0xff ,(char *)eep.resume.fname ) != 0 ) {
		sys.playMode = PLAY_STS_ACCESS_ERROR;
		eep.resume.mode = RESUME_NONE;
		strcpy_P( (char *)sys.textBuffer ,PSTR("JgACej") );
		return ( sys.playMode );
	}

	/* t@C擾						*/
	uint8_t ret = getPlayFileInfo( (char *)eep.resume.fname ,(PLAY_FILE_INFO *)&sys.playInfo );
	if ( ret == 1 ) {
		sys.playMode = PLAY_STS_ACCESS_ERROR;
		eep.resume.mode = RESUME_NONE;
		sprintf_P( (char *)sys.textBuffer ,PSTR("̧ٵݴװ1 [%s]") ,sys.playList.items[sys.playList.index].fname );
		return ( sys.playMode );

	} else if ( ret ) {
		sys.playMode = PLAY_STS_NOT_SYPPORT;
		sprintf_P( (char *)sys.textBuffer ,PSTR("Ή̃t@CłB [%s]") ,sys.playList.items[sys.playList.index].fname );
		eep.resume.mode = RESUME_NONE;
		return ( sys.playMode );
	}

	/* t@CI[v						*/
	if ( f_open( (FIL *)&sys.playFL ,(char *)eep.resume.fname ,FA_READ ) != FR_OK ) {
		sys.playMode = PLAY_STS_ACCESS_ERROR;
		eep.resume.mode = RESUME_NONE;
		sprintf_P( (char *)sys.textBuffer ,PSTR("̧ٵݴװ2 [%s]") ,sys.playList.items[sys.playList.index].fname );
		return ( sys.playMode );
	}

	/*														*/
	/* W[										*/
	/* MIDIĐ128{ŖړI̎Ԃ܂ōĐs	*/
	/* MIDIȊOłDSP@\ŖړĨt@CʒuփV[N	*/
	/*														*/
	if ( ( mode == PLAY_CURRENT ) && ( eep.resume.mode == RESUME_SEEK ) ) {

		/* MIDȈꍇ128{[hŖړIʒu܂ōĐ	*/
		if ( sys.playInfo.type == F_MIDI ) {
			vsRegWrite( SCI_DECODE_TIME ,0 );			/* DSP̍ĐԃWX^NA	*/
			vsRegWrite( SCI_DECODE_TIME ,0 );			/* 2񏑂ނƂŊmɃNA	*/
			vsWriteXmem( X_PLAYSPEED ,128 );			/* 128{Đ						*/
			t = (uint16_t)( eep.resume.time / 100L );
			while ( sys.playFL.fptr < sys.playFL.fsize ) {
				wdt_reset();
				if ( f_forward( (FIL *)&sys.playFL ,vsOutStream ,64 ,&n ) != FR_OK ) {
					sys.playMode = PLAY_STS_ACCESS_ERROR;
					eep.resume.mode = RESUME_NONE;
					strcpy_P( (char *)sys.textBuffer ,PSTR("V[NG[") );
					return ( sys.playMode );
				}
				if ( t <= vsRegRead( SCI_DECODE_TIME ) ) {
					break;
				}
			}
			vsWriteXmem( X_PLAYSPEED ,1 );

		/* MIDIȊȌꍇ̓t@CV[N					*/
		} else {

			/* DoNotJumptONA܂Ńf[^𑗂*/
			/* DoNotJumpsv(MP3)̏ꍇ͉Ȃ	*/
			if ( sys.playInfo.type & DO_NOT_JUMP_BIT ) {

				/* DoNotJumptONA܂łŃf[^𑗐M			*/
				do {
					if ( f_forward( (FIL *)&sys.playFL ,vsOutStream ,64 ,&n ) != FR_OK ) {
						sys.playMode = PLAY_STS_ACCESS_ERROR;
						eep.resume.mode = RESUME_NONE;
						strcpy_P( (char *)sys.textBuffer ,PSTR("V[NG[") );
						return ( sys.playMode );
					}
				} while ( ( sys.playFL.fptr < sys.playFL.fsize ) && ( vsRegRead( SCI_STATUS ) & 0x8000 ) );

				/* endFillByte 2052 o */
				uint8_t endFillByte = (uint8_t)( vsReadXmem( X_ENDFILLBYTE ) & 0x00ff );
				n = 2052;
				while ( n ) {
					wdt_reset();
					if ( vsOutFill( 0 ,0 ) != 0 ) {
						n -= vsOutFill( endFillByte ,n );
					}
				}
			}

			/* ubNTCYLȎ̓f[^E킹	*/
			if ( sys.playInfo.blockSize != 0 ) {
				if ( eep.resume.fpos > sys.playInfo.startPos ) {
					uint32_t tmp = ( eep.resume.fpos - sys.playInfo.startPos ) / (uint32_t)sys.playInfo.blockSize;
					eep.resume.fpos = sys.playInfo.startPos + ( tmp * (uint32_t)sys.playInfo.blockSize );
				}
			}

			/* t@CV[N */
			if ( f_lseek( (FIL *)&sys.playFL ,eep.resume.fpos ) != FR_OK ) {
				sys.playMode = PLAY_STS_ACCESS_ERROR;
				eep.resume.mode = RESUME_NONE;
				strcpy_P( (char *)sys.textBuffer ,PSTR("V[NG[") );
				return ( sys.playMode );
			}
		}
		sys.playTime = eep.resume.time;
		player_volumeFade( VOLUME_FADE_IN );

	} else {
		sys.playTime = 0L;
		eep.playTimeDisable = 0;
		player_volume( eep.volume );
	}

	eep.resume.mode = RESUME_NONE;
	sys.tickPlayTime = 1;
	sys.playMode = PLAY_STS_PLAYING;

	/* GtFNgݒ					*/
	vsHighPitchedSoundEmphasis( eep.hi_freq ,eep.hi_lv );
	vsBassEmphasis( eep.low_freq ,eep.low_lv );
	vsSetEarSpeaker( eep.earSpeaker );

	/* DSPւ̓]݋			*/
	dspEnable();

	/* DSPւ̓]ݏmɎsl 10msec ̑҂	*/
	WAIT_MS( 10 );

	return ( PLAY_STS_PLAYING );
}

/*****************************************************************************
*							Ȃ̍Đꎞf
* Fvoid
* ߒlFvoid
* ̊֐̓W[쐬čĐ~
*****************************************************************************/
void player_pause( void )
{
	dspDisable();									/* DSP]݋֎~	*/
	memset( (void *)&eep.resume ,0x00 ,sizeof(eep.resume) );

	if ( sys.playMode & PLAY_STS_OPEN_BIT ) {

		playList_getItemName( (PLAYLIST *)&sys.playList ,0xff ,(char *)eep.resume.fname );
		eep.resume.time = sys.playTime;
		eep.resume.fpos = sys.playFL.fptr;

		if ( ( eep.resume.fname[0] != '\0' ) && 
			 ( ( sys.playMode == PLAY_STS_PLAYING ) ||
			   ( sys.playMode == PLAY_STS_PAUSE   ) ||
			   ( sys.playMode == PLAY_STS_FAINARAIZ ) ) ) {
			if ( sys.playInfo.type == F_MIDI ) {
				uint32_t bytesLeft = vsReadXmemDword( X_BYTES_LEFT );
				if ( bytesLeft ) {
					eep.resume.mode = RESUME_SEEK;
				} else {
					eep.resume.mode = RESUME_TOP;
				}
			} else {
				eep.resume.mode = RESUME_SEEK;
			}
		} else if ( sys.playMode == PLAY_STS_FINISH ) {
			eep.resume.mode = RESUME_NEXT;
		}
	}

	/* Đ~						*/
	player_stop();
	sys.playMode = PLAY_STS_PAUSE;
}

/*****************************************************************************
*								Ȃ̍Đ~
* Fvoid
* ߒlFvoid
*****************************************************************************/
void player_stop( void )
{
	uint16_t data;

	/* DSP]荞݋֎~							*/
	dspDisable();

	/* DSP]荞ݕϐNA					*/
	regType = 0;									/* 擾郌WX^				*/
	dspBusy = 0;									/* MIDIĐDSPrW[tO	*/
	endFillByte = 0;								/* endFillByte̒l				*/
	endFillByteCounter = 0;							/* MendFillByte ̐		*/

	/* DSPp[^WX^ޔϐNA			*/
	memset( (void *)sys.dsp_spectrum ,0x00 ,sizeof(sys.dsp_spectrum) );
	sys.dsp_hDat0 = 0;
	sys.dsp_hDat1 = 0;
	sys.dsp_auData = 0;
	sys.enableSpectrum = 0;

	/* t@CN[Y								*/
	if ( sys.playMode & PLAY_STS_OPEN_BIT ) {
		f_close( (FIL *)&sys.playFL );
	}

	/* DoNotJumptONA						*/
	data = vsRegRead( SCI_STATUS );
	data &= ~0x8000;
	vsRegWrite( SCI_STATUS ,data );

	sys.playMode = PLAY_STS_STOP;
}

/*****************************************************************************
*							v[[ʂݒ
* Fuint8_t vol
* ߒlFvoid
*****************************************************************************/
void player_volume( uint8_t vol )
{
	if ( vol <= VOLUME_MAXVALUE ) {
		/* DSP]荞݋֎~		*/
		dspDisable();

		/* DSP̉ʐݒ			*/
		player_volumeFade( VOLUME_FADE_NONE );
		vsSetVolume( pgm_read_byte( &volumeTable[ vol ] ) );
		eep.volume = vol;

		/* DSP]荞ݕ		*/
		if ( sys.playMode & PLAY_STS_DSP_BIT ) {
			dspEnable();
		}
	}
}

/*****************************************************************************
*								TEh
* FSOUND_TYPE type TEh^Cv
* ߒlFvoid
* ̊֐sDSP]݂֎~
*****************************************************************************/
void player_sound( SOUND_TYPE type )
{
	/* DSP]荞݋֎~		*/
	dspDisable();

	switch ( type ) {
		case SOUND_LOWBATT:						/* obe[dቺVbg_E	*/
			vsBeep( 880 ,3 ,80 );
			break;

		case SOUND_ALERT:						/* obe[dቺx			*/
			vsBeep( 880 ,2 ,150 );
			break;

		case SOUND_ERROR:						/* VXeG[					*/
			vsBeep( 220  ,1 ,250 );
			break;

		case SOUND_POWER_ON:					/* dON							*/
			vsBeep( 1680 ,1 ,75 );
			vsBeep( 880 ,1 ,75 );
			break;

		case SOUND_POWER_OFF:					/* dOFF							*/
			vsBeep( 880 ,1 , 75 );
			vsBeep( 1680 ,1 , 75 );
			break;

		case SOUND_NEXT_MUSIC:					/* ̋							*/
			vsBeep( 3000 ,2 ,60 );
			break;

		case SOUND_BACK_MUSIC:					/* Ő							*/
			vsBeep( 3000 ,2 ,60 );
			break;

		case SOUND_TOP_OF_MUSIC:				/* Đ̋Ȃ̐擪ɖ߂			*/
			vsBeep( 3000 ,1 ,60 );
			break;

		case SOUND_PAUSE:						/* |[Y							*/
			vsBeep( 1680 ,1 ,60 );
			break;

		case SOUND_CHANGE_MODE:					/* v[[EWI[hؑւ̉	*/
			vsBeep( 2000 ,2 ,60 );
			break;

		case SOUND_CHANGE_STATION:				/* FMWIǕύX̉			*/
			vsBeep( 1200 ,1 ,60 );
			break;

		case SOUND_SEEK_START:					/* FMWIXLJn̉	*/
			vsBeep( 1200 ,2 ,60 );
			break;

		default:
			break;
	}
}

