/*###########################################################################
#																			#
#								񑀍֐Q						@@#
#																			#
###########################################################################*/
#ifndef __STRING_FUNC_H__
#define __STRING_FUNC_H__
#include <avr/io.h>

#ifndef NULL
#define NULL (void *)0
#endif

/*	S-JIS1oCgڃ`FbN	*/
#ifndef IS_SJIS1
#define IS_SJIS1(code) ( ( ( (uint8_t)(code) >= 0x81 ) && ( (uint8_t)(code) <= 0x9f ) ) || ( ( (uint8_t)(code) >= 0xe0 ) && ( (uint8_t)(code) <= 0xfc ) ) )
#endif

/*	S-JIS2oCgڃ`FbN	*/
#ifndef IS_SJIS2
#define IS_SJIS2(code) ( ( ( (uint8_t)(code) >= 0x40 ) && ( (uint8_t)(code) <= 0x7e ) ) || ( ( (uint8_t)(code) >= 0x80 ) && ( (uint8_t)(code) <= 0xfc ) ) )
#endif

/* ֐vg^Cv錾						*/
uint8_t isDecimalNumber( char c );
uint8_t isDecimalNumberString( char *str );
uint8_t atou16( char *str ,uint16_t *val );
void utoa_kanma( uint32_t n ,char *s ,uint8_t k );
void strtrim( char *s );
char *getFileName( char *path );
char *getExtension( char *path );
void getFilePath( char *fname ,char *path );
char *inStrRev( char *s ,char c );
uint16_t getCharCode( char **s );
uint16_t getCharCode_P( prog_char **s );
uint8_t strcat_s( char *strDestination ,uint16_t numberOfElements ,char *strSource );
uint8_t strcat_s_P( char *strDestination ,uint16_t numberOfElements ,const prog_char *strSource );
uint8_t strcpy_s( char *strDestination ,uint16_t numberOfElements ,char *strSource );
uint8_t strcpy_s_P( char *strDestination ,uint16_t numberOfElements ,const prog_char *strSource );

#endif
