/*###########################################################################
#                                                                           #
#          	LCDW[uZY-FGD1442701V1v䃂W[					#
#                                                                           #
# [hf[^͏ʁEʂ̏Ԃŏo͂邱								#
# AVR̃oXɒ CS0=A15 / CD = A13	RD/WR/DATA						#
# obNCgLEDPB7Ő䂷(Lowœ_/Hiŏ)						#
# PB7Timer0PWMŋPxύXł									#
#                                                                           #
# _̕`^`̕`^̕`^ȒPASCII\݂̂T|[g	#
#                                                                           #
###########################################################################*/
#ifndef __ZY_FGD1442701V1_H__
#define __ZY_FGD1442701V1_H__

#include <avr/io.h>
#include <avr/pgmspace.h>

/* W`֐̎gp				*/
#define LCD_USE_GRAPHIC 1				/* 0:gp !0:gp						*/
										/* lcdPset() / lcdFillBox()				*/
										/* lcdBox() / lcdLine()					*/

/* `bvZbg}N			*/
#define LCD_ENABLE_RESET()			( PORTG &= ~_BV(3) )
#define LCD_DISABLE_RESET()			( PORTG |=  _BV(3) )

/* LCDAhX`					*/
#define LCD_CMD (*(volatile uint8_t *)0x4000)
#define LCD_DAT (*(volatile uint8_t *)0x6000)

/* XN[TCY					*/
#define SCREEN_WIDTH 128
#define SCREEN_HEIGHT 128

/* [hf[^				*/
#define LCD_WORD_WRITE(a) { LCD_DAT = (uint8_t)((a) >> 8); LCD_DAT = (uint8_t)(a) & 0x00ff; }

/* [hf[^ǂݍ				*/
#define LCD_WORD_READ() ( ( (uint16_t)LCD_DAT << 8 ) | (uint16_t)LCD_DAT )

/* \_ijݒ				*/
#define LCD_START_POSION 4			/* 1 : FPCɂČlɕ\			*/
									/* 2 : FPCɂČlɕ\			*/
									/* 3 : FPCɂČlɕ\			*/
									/* 4 : FPCEɂČlɕ\			*/

/* WItZbg`				*/
#if (LCD_START_POSION == 1 )
#define LCD_COL_OFFSET 2
#define LCD_ROW_OFFSET 3
#define LCD_MADCTL_PARA 0xc8		/* MY-MX-MV-ML-RGB-MH-0-0 = 11001000		*/

#elif (LCD_START_POSION == 2 )
#define LCD_COL_OFFSET 2
#define LCD_ROW_OFFSET 1
#define LCD_MADCTL_PARA 0x08		/* MY-MX-MV-ML-RGB-MH-0-0 = 00001000		*/

#elif (LCD_START_POSION == 3 )
#define LCD_COL_OFFSET 1
#define LCD_ROW_OFFSET 2
#define LCD_MADCTL_PARA 0x68		/* MY-MX-MV-ML-RGB-MH-0-0 = 01101000		*/

#elif (LCD_START_POSION == 4 )
#define LCD_COL_OFFSET 3
#define LCD_ROW_OFFSET 2
#define LCD_MADCTL_PARA 0xa8		/* MY-MX-MV-ML-RGB-MH-0-0 = 10101000		*/

#else
#error Do not forget to set LCD_START_POSION
#endif

/* LCD_COLMOD WX^l			*/
#define LCD_COLMOD_12BIT 0x03		/* 12bit mode(RRRRGGGG BBBRRRR GGGGBBBB)	*/
#define LCD_COLMOD_16BIT 0x05		/* 16bit mode(RRRRRGGG GGGBBBBB)			*/
#define LCD_COLMOD_18BIT 0x06		/* 18bit mode(RRRRRRxx GGGGGGxx BBBBBBxx)   */

/* LCD R}h`					*/
#define LCD_SWRESET		0x01
#define LCD_RDDID		0x04
#define LCD_RDDST		0x09
#define LCD_RDDPM		0x0a
#define LCD_RDDMADCTL	0x0b
#define LCD_RDDCOLMOD	0x0c
#define LCD_RDDIM		0x0d
#define LCD_RDDSM		0x0e
#define LCD_SLPIN		0x10
#define LCD_SLPOUT		0x11
#define LCD_PTLON		0x12
#define LCD_NORON		0x13
#define LCD_INVOFF		0x20
#define LCD_INVON		0x21
#define LCD_GAMSET		0x26
#define LCD_DISPOFF		0x28
#define LCD_DISPON		0x29
#define LCD_CASET		0x2a
#define LCD_RASET		0x2b
#define LCD_RAMWR		0x2c
#define LCD_RAMRD		0x2e
#define LCD_PTLAR		0x30
#define LCD_TEOFF		0x34
#define LCD_TEON		0x35
#define LCD_MADCTL		0x36
#define LCD_IDMOFF		0x38
#define LCD_IDMON		0x39
#define LCD_COLMOD		0x3a
#define LCD_RDID1		0xda
#define LCD_RDID2		0xdb
#define LCD_RDID3		0xdc
#define LCD_FRMCTR1		0xb1
#define LCD_FRMCTR2		0xb2
#define LCD_FRMCTR3		0xb3
#define LCD_INVCTR		0xb4
#define LCD_DISSET5		0xb6
#define LCD_PWCTR1		0xc0
#define LCD_PWCTR2		0xc1
#define LCD_PWCTR3		0xc2
#define LCD_PWCTR4		0xc3
#define LCD_PWCTR5		0xc4
#define LCD_VMCTR1		0xc5
#define LCD_VMOFCTR		0xc7
#define LCD_WRID2		0xd1
#define LCD_WRID3		0xd2
#define LCD_PWCTR6		0xfc
#define LCD_NVCTR1		0xd9
#define LCD_NVCTR2		0xde
#define LCD_NVCTR3		0xdf
#define LCD_GAMCTRP1	0xe0
#define LCD_GAMCTRN1	0xe1
#define LCD_EXTCTRL		0xf0
#define LCD_VCOM4L		0xff

/* JAhXݒ				*/
#define LCD_SET_COLUM_ADDRESS(x1,x2) {			\
	LCD_CMD = LCD_CASET;						\
	LCD_WORD_WRITE( LCD_COL_OFFSET + (x1) );	\
	LCD_WORD_WRITE( LCD_COL_OFFSET + (x2) );	\
}

/* [AhXݒ					*/
#define LCD_SET_ROW_ADDRESS(y1,y2) {			\
	LCD_CMD = LCD_RASET;						\
	LCD_WORD_WRITE( LCD_ROW_OFFSET + (y1) );	\
	LCD_WORD_WRITE( LCD_ROW_OFFSET + (y2) );	\
}

/* Fϊ}N (r,g,b e0`255) */
#define RGB(r,g,b) ( ( ( (uint16_t)(r) << 8 ) & 0xf800 ) | ( ( (uint16_t)(g) << 3 ) & 0x07e0 ) |( ( (uint16_t)(b) >> 3 ) & 0x001f ) )

/* Fϊ}N (r 0`31 / g 0`63 / b 0`31 )@*/
#define RGB16(r,g,b) ( ( (uint16_t)(r & 0x1f) << 11 ) | ( (uint16_t)(g & 0x3f) << 5 ) | (uint16_t)(b & 0x1f) )

/* ֐vg^Cv錾		*/
void lcdInit( void );
void lcdSetBrightness( uint8_t lv );
void lcdOn( void );
void lcdOff( void );
void lcdClear( void );

#if ( LCD_USE_GRAPHIC != 0 )
void lcdPset( uint8_t x ,uint8_t y ,uint16_t color );
void lcdFillBox( uint8_t x1 ,uint8_t y1 ,uint8_t x2 ,uint8_t y2 ,uint16_t color );
void lcdBox( uint8_t x1 ,uint8_t y1 ,uint8_t x2 ,uint8_t y2 ,uint16_t color );
void lcdLine( uint8_t x1 ,uint8_t y1 ,uint8_t x2 ,uint8_t y2 ,uint16_t color );
#endif

void lcdPutc( uint8_t x ,uint8_t y ,char c ,uint16_t fontColor ,uint16_t bgColor );
void lcdPuts( uint8_t x ,uint8_t y ,char *str ,uint16_t fontColor ,uint16_t bgColor );
void lcdPuts_P( uint8_t x ,uint8_t y ,const prog_char *str ,uint16_t fontColor ,uint16_t bgColor );
const prog_uint8_t *lcdGetFontImage( char c );
void lcdRectClip( uint8_t *x1 ,uint8_t *y1 ,uint8_t *x2 ,uint8_t *y2 );

#endif
